> ## Documentation Index
> Fetch the complete documentation index at: https://developers.dwolla.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Initiate or Verify micro-deposits

> Handles micro-deposit bank verification process. Make a request without a request body to initiate two small deposits to the customer's bank account. Include deposit amounts to verify the received values and complete verification.



## OpenAPI

````yaml post /funding-sources/{id}/micro-deposits
openapi: 3.1.0
info:
  title: Dwolla API
  description: Dwolla API Documentation
  contact:
    name: Dwolla Developer Relations Team
    url: https://developers.dwolla.com
    email: api@dwolla.com
  version: '2.0'
  termsOfService: https://www.dwolla.com/legal/tos/
  license:
    name: MIT
    url: https://github.com/Dwolla/dwolla-openapi/blob/master/LICENSE
servers:
  - url: https://api.dwolla.com
    description: Production server
  - url: https://api-sandbox.dwolla.com
    description: Sandbox server
security:
  - clientCredentials: []
tags:
  - name: tokens
    description: Operations related to Application Access Tokens
  - name: root
    description: Root API operations
  - name: accounts
    description: Operations related to Accounts
  - name: customers
    description: Operations related to Customers
  - name: kba
    description: Operations related to Knowledge-Based Authentication
  - name: beneficial owners
    description: Operations related to Beneficial Owners
  - name: documents
    description: Operations related to Documents
  - name: exchanges
    description: Operations related to Exchanges
  - name: exchange sessions
    description: Operations related to Exchange Sessions
  - name: funding sources
    description: Operations related to Funding Sources
  - name: transfers
    description: Operations related to Transfers
  - name: labels
    description: Operations related to Labels
  - name: mass payments
    description: Operations related to Mass Payments
  - name: events
    description: Operations related to Events
  - name: webhook subscriptions
    description: Operations related to Webhook Subscriptions
  - name: webhooks
    description: Operations related to Webhooks
  - name: client tokens
    description: Operations related to Client Tokens
  - name: sandbox simulations
    description: Sandbox-only operations for simulating processing of bank transfers
paths:
  /funding-sources/{id}/micro-deposits:
    post:
      tags:
        - funding sources
      summary: Initiate or Verify micro-deposits
      description: >-
        Handles micro-deposit bank verification process. Make a request without
        a request body to initiate two small deposits to the customer's bank
        account. Include deposit amounts to verify the received values and
        complete verification.
      operationId: initiateOrVerifyMicroDeposits
      parameters:
        - name: id
          in: path
          description: The ID of the FS to initiate or verify micro-deposit
          required: true
          schema:
            type: string
        - $ref: '#/components/parameters/Accept'
      requestBody:
        required: false
        description: |
          Optional request body for verifying micro-deposits.
          - If omitted: Endpoint will initiate micro-deposits
          - If provided: Must contain micro-deposit amounts for verification
        content:
          application/json:
            schema:
              oneOf:
                - type:
                    - object
                    - 'null'
                  title: InitiateMicroDeposits
                  description: No request body is required for initiating micro-deposits.
                - $ref: '#/components/schemas/VerifyMicroDeposits'
                  description: Required request body for verifying micro-deposits
      responses:
        '200':
          description: successful operation
          headers: {}
          content:
            application/vnd.dwolla.v1.hal+json:
              schema:
                type: object
                description: >-
                  Response for microdeposits operations (initiation and
                  verification)
                properties:
                  _links:
                    type: object
                    properties:
                      self:
                        type: object
                        properties:
                          href:
                            type: string
                            format: uri
                            example: >-
                              https://api-sandbox.dwolla.com/funding-sources/2e446d1b-fb3c-42a0-9691-5d1d6a4dbbf0/micro-deposits
                          type:
                            type: string
                            example: application/vnd.dwolla.v1.hal+json
                          resource-type:
                            type: string
                            example: micro-deposits
        '201':
          description: created
          headers:
            Location:
              $ref: '#/components/headers/Location'
        '403':
          description: forbidden
          headers: {}
          content:
            application/vnd.dwolla.v1.hal+json:
              schema:
                type: object
                properties:
                  code:
                    type: string
                    example: InvalidResourceState
                  message:
                    type: string
                    example: Bank already verified.
        '404':
          description: not found
          headers: {}
          content:
            application/vnd.dwolla.v1.hal+json:
              schema:
                type: object
                properties:
                  code:
                    type: string
                    example: NotFound
                  message:
                    type: string
                    example: The requested resource was not found.
      x-codeSamples:
        - lang: bash
          source: >
            POST
            https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909/micro-deposits

            Authorization: Bearer
            8tJjM7iTjujLthkbVPMUcHLqMNw4uv5kG712g9j1RRBHplGpwo

            Content-Type: application/vnd.dwolla.v1.hal+json

            Accept: application/vnd.dwolla.v1.hal+json
        - lang: javascript
          source: |
            var fundingSourceUrl =
              "https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909";

            dwolla.post(`${fundingSourceUrl}/micro-deposits`);
        - lang: python
          source: >
            # Using dwollav2 - https://github.com/Dwolla/dwolla-v2-python

            funding_source_url =
            'https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909'


            app_token.post('%s/micro-deposits' % funding_source_url)
        - lang: php
          source: >
            <?php

            // Using dwollaswagger -
            https://github.com/Dwolla/dwolla-swagger-php

            $fundingSourceUrl =
            'https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909';


            $fsApi = new DwollaSwagger\FundingsourcesApi($apiClient);


            $fsApi->microDeposits(null, $fundingSourceUrl);

            ?>
        - lang: ruby
          source: >
            # Using dwolla_v2 - https://github.com/Dwolla/dwolla-v2-ruby

            funding_source_url =
            'https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909'


            app_token.post "#{funding_source_url}/micro-deposits"
components:
  parameters:
    Accept:
      name: Accept
      in: header
      required: true
      description: >-
        The media type of the response. Must be
        application/vnd.dwolla.v1.hal+json
      schema:
        type: string
        enum:
          - application/vnd.dwolla.v1.hal+json
        default: application/vnd.dwolla.v1.hal+json
  schemas:
    VerifyMicroDeposits:
      title: VerifyMicroDeposits
      description: Request body for verifying micro-deposits
      type: object
      required:
        - amount1
        - amount2
      properties:
        amount1:
          type: object
          required:
            - value
            - currency
          properties:
            value:
              type: string
              example: '0.02'
            currency:
              type: string
              example: USD
        amount2:
          type: object
          required:
            - value
            - currency
          properties:
            value:
              type: string
              example: '0.03'
            currency:
              type: string
              example: USD
  headers:
    Location:
      description: The location of the created resource
      schema:
        type: string
  securitySchemes:
    clientCredentials:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: /token
          x-speakeasy-token-endpoint-authentication: client_secret_basic
          scopes: {}

````